package ca.svarb.utils;

import java.util.Collection;

/**
 * Some static text utility methods 
 *
 */
public class TextUtils {
	
	/**
	 * Creates a delimited string from the input list, separating each
	 * value with the given delimiter string.
	 * @param objects
	 * @param delimiter
	 * @throws NullPointerException if either argument is null
	 * @return
	 */
	public static String buildDelimitedString(Collection<?> objects, String delimiter) {
		ArgumentChecker.checkNulls("objects", objects, "delimiter", delimiter);
		StringBuffer buf = new StringBuffer();
		String nextDelim="";
		for (Object object : objects) {
			buf.append(nextDelim);
			buf.append(object);
			nextDelim=delimiter;
		}
		return buf.toString();
	}
	
	/**
	 * Returns the length of the longest non-null string in the collection.
	 * 
	 * Collection must have at least one non-null entry.
	 * 
	 * @param objects 
	 * @return IllegalArgumentException If the collection is null
	 * or contains only null elements.
	 */
	public static int findLongestString(Collection<?> objects) {
		ArgumentChecker.checkForEmptyCollection("objects", objects);
		int maxLength=0;
		for (Object object : objects) {
			if (object!=null) {
				int length = object.toString().length();
				if(length>maxLength) maxLength=length;
			}
		}
		return maxLength;
	}
}
